AT(1)

NAMN
at, batch, atq, atrm — köa upp, undersök eller radera jobb att köras senare

SYNOPSIS
at [-V] [-q queue] [-f file] [-u username] [-mMlv] timespec ..."
at [-V] [-q kö] [-f fil] [-u användarnamn] [-mMkv] [-t tid]
at -c jobb […]
at [-V] -l [-o tidsformat] [jobb …]
atq [-V] [-q kö] [-o tidsformat] [jobb …]
at [-rd] jobb […]
atrm [-V] jobb […]
batch
at -b

BESKRIVNING
at och batch läser kommandon från standard in eller en angiven fil vilka skall köras vid ett senare tillfälle med /bin/sh.

at  kör kommandon vid en angiven tid

atq listar användarens väntande jobb, om inte användaren är superanvändaren; i så fall listas allas jobb. Formatet på utdatarader (en för varje jobb) är: jobbnummer, datum, tid, kö och användarnamn.

atrm
    raderar jobb, identifierade med sina jobbnummer.

batch
    kör kommandon när systemlasten tillåter; med andra ord, när genomsnittslasten sjunker under 1,5, eller värdet som anges vid starten av atd.

At tillåter ganska komplexa tidsangivelser som utökar standarden POSIX.2. Det godtar tider på formen HH:MM för att köra ett jobb vid en viss tid på dagen. (Om den tiden redan har passerat antas nästa dag.) Man kan även ange midnight, noon eller teatime (16) och man kan ange en tid på dagen med ett suffix AM eller PM för att köra på morgonen eller kvällen. Man kan även ange vilken dag jobbet skall köras, genom att ange ett datum på formatet månadsnamn dag med ett frivilligt år eller ge ett datum på formatet MMDD[ÅÅ]ÅÅ, MM/DD/[ÅÅ]ÅÅ, DD.MM.[ÅÅ]ÅÅ or [ÅÅ]ÅÅ-MM-DD. Specifikationen av ett datum måste komma efter specifikationen av tiden på dagen. Man kan även ange tider som now + antal tidsenheter, där tidsenheten kan vara minutes, hours, days eller weeks och man kan säga till at att köra jobbet idag genom att följa tiden med today och att köra jobbet imorgon genom att följa tiden med tomorrow.

Till exempel, för att köra ett jobb klockan 16 om tre dagar skulle man göra at 4pm + 3 days, för att köra ett jobb klockan 10 den 31 juli, skulle man göra at 10am Jul 31 och för att köra ett jobb klockan 1 på natten imorgon, skulle man göra at 1:00 tomorrow.

Om man anger ett jobb att absolut köra på vid en passerad tidpunkt och datum kommer jobbet köra så snart som möjligt. Till exempel, om klockan är 20 och man gör en at 18:00 today kommer det förmodligen att köra 20:05.

Definitionen av tidsangivelsen finns i /usr/share/doc/at/timespec.

För både at och batch läses kommandon från standard in eller den angivna filen med flaggan -f och körs. Arbetskatalogen, miljön (utom för variablerna BASH_VERSINFO, DISPLAY, EUID, GROUPS, SHELLOPTS, TERM, UID och _) och umasken behålls från anropstillfället.

Eftersom at för närvarande är implementerat som ett setuid-program exporteras inte heller andra miljövariabler (t.ex., LD_LIBRARY_PATH eller LD_PRELOAD). Detta kan komma att ändras i framtiden. För att gå runt problemet, sätt uttryckligen dessa variabler i jobbet.

Ett at- eller batch-kommando anropat från ett su(1)-skal kommer behålla det aktuella användar-id:t. Användaren kommer att få ett brev med standard fel och standard ut från sitt kommando, om det blir någon. Post kommer skickas med kommandot /usr/sbin/sendmail. Om at körs from ett su(1)-skal kommer ägaren av inloggningsskalet att ta brevet.

Superanvändaren kan använda dessa kommandon under alla omständigheter. För andra användare avgörs rättigheten att använda dem av filerna /etc/at.allow och /etc/at.deny. Se at.allow(5) för detaljer.

FLAGGOR

-V  skriver ut versionsnumret till standard fel och avslutar felfritt.

-q kö
    använder den angivna kön. En köbeteckning består av en ensam bokstav; giltiga köbeteckningar går från a till z och A till Z. Kön a är standard för at och kön b för batch. Köer med högre bokstäver kör med högre värde på nice. Specialkön ”=” är reserverad för jobb som kör just nu.

Om ett jobb skickas till en köbeteckning med en versal bokstav behandlas jobbet som om det vore skickat till batch vid jobbtidpunkten. När tiden uppnåtts gäller reglerna för batch-körning med avseende på genomsnittslast. Om atq ges en specifik kö kommer den endast att visa jobb som väntar i den kön.

-m  Skicka brev till användaren när jobbet har avslutats även om det inte fanns någon utdata.

-M  Skicka aldrig brev till användaren.

-u användarnamn
    Skickar brev till användarnamn istället för den aktuella användaren.

-f fil
    Läser jobbet från fil istället för standard in.

-t tid
    kör jobbet vid tid, som ges på formatet [[ÅÅ]ÅÅ]MMDDhhmm[.ss]

-l  Är ett alias för atq.

-r  Är ett alias för atrm.

-d  Är ett alias för atrm.

-b  är ett alias för batch.

-v  Visar tiden jobbet kommer köras före jobbet läses in.

Tider visas på formatet ”Thu Feb 20 14:50:00 1997”.

-c  konkatenerar jobben listade på kommandoraden till standard ut.

-o fmt
    strftime-likt tidsformat använt för jobblistan

FILER
/var/spool/cron/atjobs
/var/spool/cron/atspool
/proc/loadavg
/var/run/utmp
/etc/at.allow
/etc/at.deny

SE ÄVEN
at.allow(5), at.deny(5), atd(8), cron(1), nice(1), sh(1), umask(2).

FEL
För att fungera korrekt beror batch för Linux på närvaron av en katalog av proc-typ monterad på /proc.

Om filen /var/run/utmp inte är tillgänglig eller trasig, eller om användaren inte är inloggad när at körs, skickas brevet till det användar-id som finns i miljövariabeln LOGNAME. Om den är odefinierad eller tom används det aktuella användar-id:t.

At och batch så som de för närvarande är implementerade är inte lämpliga när användare tävlar om resurser. Om detta är fallet på ens sajt kan man vilja överväga ett annat batch-system, såsom nqs.

UPPHOVSMAN
At skrevs huvudsakligen av Thomas König.

ÖVERSÄTTNING
Den svenska översättningen av denna manualsida skapades av Göran Uddeborg <goeran@uddeborg.se>

Denna översättning är fri dokumentation; läs GNU General Public License Version 3 (https://www.gnu.org/licenses/gpl-3.0.html) eller senare för upphovsrättsvillkor. Vi tar INGET ANSVAR.

Om du hittar fel i översättningen av denna manualsida, skicka ett mail till Tp-sv@listor.tp-sv.se.